package ccc

import javax.swing.event.TreeSelectionEvent

class CccController {
    // these will be injected by Griffon
    def model
    def view

    // void mvcGroupInit(Map args) {
    //    // this method is called after model and view are injected
    // }

    // void mvcGroupDestroy() {
    //    // this method is called when the group is destroyed
    // }

    def folderChanged = { TreeSelectionEvent evt = null ->
        model.currentFile = evt.newLeadSelectionPath?.lastPathComponent
        app.event('FolderChanged')
    }

    def onFolderChanged = {
        view.content.model.rowsModel.value = model.currentFile ? model.currentFile?.listFiles() : []
        view.content.model.fireTableDataChanged()
    }

    def open = {
        "xdg-open \"$model.selectedFile.absolutePath\"".execute()
    }

    def details = {
        def dialog = buildMVCGroup('Details')
        dialog.model.file = model.selectedFile
        dialog.view.dialog.pack()
        dialog.view.dialog.visible = true
        destroyMVCGroup('Details')
    }
}
