package ccc

import groovy.beans.ListenerList
import javax.swing.event.TreeModelListener
import javax.swing.tree.TreeModel
import javax.swing.tree.TreePath

class FolderModel implements TreeModel {
    File root
    @ListenerList
    List<TreeModelListener> listeners

    FolderModel(File root) {
        this.root = root
    }

    Object getRoot() {
        return root
    }

    Object getChild(Object parent, int index) {
        try {
            return parent.listFiles({it.directory} as FileFilter)[index]
        } catch (e) {
            return -1
        }
    }

    int getChildCount(Object parent) {
        def folders = parent.listFiles({it.directory} as FileFilter)
        return folders ? folders.length : 0
    }

    boolean isLeaf(Object node) {
        return node.file
    }

    void valueForPathChanged(TreePath path, Object newValue) {
        // only needed for editable trees
    }

    int getIndexOfChild(Object parent, Object child) {
        return parent.listFiles({it.directory} as FileFilter).findIndexOf {it == child}
    }

    /*
    von @ListenerList
    void addTreeModelListener(TreeModelListener l)
    void removeTreeModelListener(TreeModelListener l)
    public TreeModelListener[] getTreeModelListeners()
    public void fireTreeNodesChanged(TreeModelEvent e)
    public void fireTreeNodesInserted(TreeModelEvent e)
    public void fireTreeNodesRemoved(TreeModelEvent e)
    public void fireTreeStructureChanged(TreeModelEvent e)
    */
}



